#include "testlib.h"
#include <numeric>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n");
    int T = 10, wt = opt<int>("wt"), tlim = opt<int>("tlim"), alim = opt<int>("alim");

    vector<int> p(n, 0);
    if (has_opt("long")) {
        iota(p.begin(), p.end(), 0);
    } else {
        int w = opt<int>("w");
        vector<int> ids(n);
        iota(ids.begin(), ids.end(), 0);
        shuffle(ids.begin() + 1, ids.end());
        for (int i = 1; i < n; i++) p[ids[i]] = ids[rnd.wnext(0, i - 1, w)] + 1;
    }

    vector<int> t(n), a(n);
    for (int &ti : t) ti = rnd.wnext(0, tlim, wt);
    for (int &ai : a) ai = rnd.next(0, alim);

    println(n, T);
    println(p.begin() + 1, p.end());
    println(t.begin() + 1, t.end());
    println(a.begin(), a.end());

}